<project name="ION-java" default="info">
	
	<!-- set global properties for this build -->
	<property name="projname" value="ioncore"/>
	<property name="version" value="0.1.0"/>
	<property name="src" location="src"/>
	<property name="build" location="build"/>
	<property name="classes" location="${build}/classes"/>
	<property name="javadoc" location="${build}/javadoc"/>
	<property name="dist"  location="dist"/>

	<path id="libs-core">
		<pathelement location="./lib/commons-cli-1.1.jar"/>
		<pathelement location="./lib/commons-io-1.2.jar"/>
		<pathelement location="./lib/json_simple-1.1.jar"/>
		<pathelement location="./lib/msgpack-0.3.jar"/>
		<pathelement location="./lib/rabbitmq-client.jar"/>
		<pathelement location="./lib/spring-amqp-1.0.0.M1.jar"/>
		<pathelement location="./lib/spring-rabbit-1.0.0.M1.jar"/>
		<pathelement location="./lib/spring-rabbit-admin-1.0.0.M1.jar"/>
		<pathelement location="./lib/org.springframework.test-3.0.4.RELEASE.jar"/>
		<pathelement location="./lib/org.springframework.oxm-3.0.4.RELEASE.jar"/>
		<pathelement location="./lib/org.springframework.core-3.0.4.RELEASE.jar"/>
		<pathelement location="./lib/org.springframework.context.support-3.0.4.RELEASE.jar"/>
		<pathelement location="./lib/org.springframework.aop-3.0.4.RELEASE.jar"/>
	</path>
		
	<path id="libs-example">
		<pathelement location="${classes}"/>
		<path refid="libs-core"/>
	</path>

	<target name="info" depends="" description="Hello">
		<echo message="ION Java library build. Please specify a target."/>
	</target>

	<!-- ================================= 
          target: compile              
         ================================= -->
	<target name="compile" depends="" description="Compile Sources">
		<mkdir dir="${classes}"/>
		<javac srcdir="${src}" destdir="${classes}" debug="on" classpathref="libs-example"/>
	</target>
	
	<!-- ================================= 
          target: runex              
         ================================= -->
	<target name="runex" depends="compile" description="Run Example">
		<java classname="ion.example.ServiceConsume">
			<classpath refid="libs-example"/>
			<sysproperty key="ioncore.sysname" value="${user.name}"/>
		</java>
	</target>

	<!-- ================================= 
          target: runex              
         ================================= -->
	<target name="runlca" depends="compile" description="Run Example">
		<java classname="ion.example.LcaDemoProcess">
			<classpath refid="libs-example"/>
			<sysproperty key="ioncore.sysname" value="${user.name}"/>
		</java>
	</target>

	<!-- ================================= 
          target: javadoc              
         ================================= -->
	<target name="javadoc" depends="" description="Generate Javadoc">
		<javadoc packagenames="ion.*"
		   sourcepath="${src}"
			classpathref="libs-example"
		   defaultexcludes="yes"
		   destdir="${javadoc}"
		   author="true"
		   version="true"
		   use="true"
		   windowtitle="ION Core">
			<doctitle><![CDATA[<h1>ION Core</h1>]]></doctitle>
			<bottom><![CDATA[<i>Copyright &#169; 2010 UC Regents. All Rights Reserved.</i>]]></bottom>
			<tag name="todo" scope="all" description="To do:"/>
		</javadoc>
	</target>
	
	<!-- ================================= 
          target: dist              
         ================================= -->
	<target name="dist" depends="clean,compile,javadoc" description="Package Distribution">
	    <!-- Create the distribution directory -->
	    <mkdir dir="${dist}/lib"/>
	    <mkdir dir="${dist}/docs"/>

	    <!-- Create JAR file with library classes, tests and example code -->
	    <jar jarfile="${dist}/lib/${projname}-full-${version}.jar" basedir="${classes}"/>

	    <!-- Create JAR file with all library classes -->
		<jar jarfile="${dist}/lib/${projname}-${version}.jar" 
	    	basedir="${classes}"
	    	excludes="ion/example/**"
		/>

	    <!-- Create ZIP file with the javadoc -->
		<zip destfile="${dist}/docs/${projname}-${version}-javadoc.zip"
			basedir="${javadoc}"
		/>		

		<!-- Create ZIP file for the entire directory -->
		<zip destfile="${dist}/${projname}-archive.zip"
			basedir="."
			excludes="${dist}/${projname}-archive.zip,${build}/**,.git/**"
		/>		
	</target>
	
	<!-- ================================= 
          target: clean              
         ================================= -->
    <target name="clean" depends="" description="Clean Outputs">
    	<delete dir="${classes}"/>
    	<delete dir="${build}"/>
    	<delete dir="${dist}"/>
    </target>

</project>